<?php
/**
 Copyright (c) 2013, Florian Schaal, info@schaal-24.de
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
 * Neither the name of ISPConfig nor the names of its contributors
 may be used to endorse or promote products derived from this software without
 specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 @author Florian Schaal, info@schaal-24.de
 @copyrighth Florian Schaal, info@schaal-24.de
 @version 0.1
*/

error_reporting(E_ALL ^ E_WARNING ^ E_DEPRECATED);  

function error($error) {
	echo $error;
	if (file_exists('/etc/postfix/main.cf.dkim')) rename('/etc/postfix/main.cf.dkim', '/etc/postfix/main.cf');
    if (file_exists('/etc/postfix/master.cf.dkim'))rename('/etc/postfix/master.cf.dkim', '/etc/postfix/master.cf');
    if (file_exists('/etc/postfix/tag_as_foreign.re.dkim'))rename('/etc/postfix/tag_as_foreign.re.dkim', '/etc/postfix/tag_as_foreign.re'); else unlink('/etc/postfix/tag_as_foreign.re');
    if (file_exists('/etc/postfix/tag_as_originating.re.dkim'))rename('/etc/postfix/tag_as_originating.re.dkim', '/etc/postfix/tag_as_originating.re'); else unlink('/etc/postfix/tag_as_originating.re');
	exit;
}

function restart ($program) {
	echo "restarting ".$program."\n";
	if (is_executable('/etc/init.d/'.$program))
		exec('/etc/init.d/'.$program.' restart', $output, $result);
	else exec('service '.$program.' restart', $output, $result);
	if ($result != 0) { 
		error("error restarting ".$program."\nAborting setup\n");
		exit;
	}
}

function get_amavis_config() {
	$pos_config=array(
		'/etc/amavisd.conf',
		'/etc/amavisd.conf/50-user',
		'/etc/amavis/conf.d/50-user',
		'/etc/amavisd/amavisd.conf'
	);
	$amavis_configfile='';
	foreach($pos_config as $conf) {
		if (is_file($conf)) {
			$amavis_configfile=$conf;
			break;
		}
	}
	return $amavis_configfile;
}

require_once '/usr/local/ispconfig/server/lib/config.inc.php';
//* Ensure that current working directory is install directory
$cur_dir = getcwd();
if(realpath(dirname(__FILE__)) != $cur_dir) die("Please run installation/update from _inside_ the patch directory!\n");

if ( $conf['app_version'] != '3.0.5.4p2' && $conf['app_version'] != '3.0.5.4p3' && $conf['app_version'] != '3.0.5.4p4' && $conf['app_version'] != '3.0.5.4p5') {
	echo "CAUTITION:\n\nThis script is for ISPConfig >= 3.0.5.4p2 - You are using ".$conf['app_version']."\n\n\nAborting setup - please update ISPCOnfig installation first.\n\nSee INSTALL.TXT for manual-setup or get an older version from this plugin\n";
	exit;
}
	
//* check for requiered config-files
$error=false;
$file='master.cf-dkim';
$check_file=file($file);
if(!is_file($file) || empty($file)) $error=true;
$file='tag_as_foreign.re';
$check_file=file($file);
if(!is_file($file) || empty($file)) $error=true;
$file='tag_as_originating.re';
$check_file=file($file);
if(!is_file($file) || empty($file)) $error=true;
$file='amavis.conf.dkim';
$check_file=file($file);
if(!is_file($file) || empty($file)) $error=true;
if ($error) {
    error("error - config-template(s) not found\nAborting setup\n");
}
unset($error);

$amavis_configfile='';
$amavis_configfile=get_amavis_config($amavis_configfile);

//* remove outdated files
if (file_exists('/usr/local/ispconfig/interface/web/js/dns_dkim.js')) unlink('/usr/local/ispconfig/interface/web/js/dns_dkim.js');
if (file_exists('/usr/local/ispconfig/interface/web/dns/dns_dkim_get.php')) unlink('/usr/local/ispconfig/interface/web/dns/dns_dkim_get.php');

if (file_exists('/usr/local/ispconfig/server/plugins-available/mail_plugin_dkim.inc.php')) {
	$update = true;
	echo "\nCreate backup? [ Y | n ]?";
	$answer=rtrim(fgets(STDIN));
	if ($answer == '' || $answer == 'Y') {
		//* create backup
		if ( !file_exists('/var/backup/') ) mkdir('/var/backup', 0700);
		$date = date("Ymd");
		echo "Create backup - /var/backup/dkim-$date.tgz\n";
		exec ('tar cfz /var/backup/dkim-'.$date.'.tgz -T backup.list &> /dev/null');
	}
} else $update = false;

echo "\nConfigure amavis? [ Y | n ]?";
$answer=rtrim(fgets(STDIN));
if ($answer == '' || $answer == 'Y') {
	echo "updating amavis (".$amavis_configfile.")\n\n";
	$content = file ($amavis_configfile);
	$file='amavis.conf.dkim';
	$new = file($file);
	foreach ($new as $line) {
    	if (!in_array($line, $content)) {
			array_push($content, $line);
		}
	}
	file_put_contents($amavis_configfile, $content);
	$amavis = true;
} else $amavis = false;

if (!is_dir('/var/lib/amavis/dkim')) {
	echo "\nDirectory for DKIM-Keys [ /var/lib/amavis/dkim ]";
	$answer=rtrim(fgets(STDIN));
	if ($answer == '') 
		$path = '/var/lib/amavis/dkim';
	else
		$path = $answer;
	exec('mkdir -p '.$path, $out, $res);
	if ($res == 0)
		echo "\n ".$path." created - check the permissions manually (750 for amavis.amavis or vscan.vscan)";
	else
		 error("error creating ".$path."\nAborting setup\n");		
}

echo "\nConfigure postfix? [ Y | n ]?";
$answer=rtrim(fgets(STDIN));
if ($answer == '' || $answer == 'Y') {
	echo "updating postfix\n\n";
	$file='tag_as_foreign.re';
	$full_file_name='/etc/postfix/tag_as_foreign.re';
	if (!copy($file, $full_file_name)) 
		error("error copying ".$file."\nAborting setup\n");

	$file='tag_as_originating.re';
	$full_file_name='/etc/postfix/tag_as_originating.re';
	if (!copy($file, $full_file_name)) 
		error("error copying ".$file."\nAborting setup\n");

	copy('/etc/postfix/main.cf', '/etc/postfix/main.cf.dkim');
	$error=false;
	exec('postconf -e "content_filter = amavis:[127.0.0.1]:10024"', $output, $result);
	if ($result != 0) $error=true;
	unset($output);unset($result);
	exec('postconf -e "smtpd_sender_restrictions = check_sender_access regexp:/etc/postfix/tag_as_originating.re, permit_mynetworks, permit_sasl_authenticated, check_sender_access mysql:/etc/postfix/mysql-virtual_sender.cf, check_sender_access regexp:/etc/postfix/tag_as_foreign.re"', $output, $result);
	if ($result != 0) $error=true;
	unset($output);unset($result);
	if ($error) {
		error("error running postconf\nAborting setup\n");
	}
	unset($error);

	$error=false;
	$full_file_name='/etc/postfix/master.cf';
	if(is_file($full_file_name)) copy($full_file_name, $full_file_name.'dkim');
	if (!copy($full_file_name, $full_file_name.'dkim')) $error=true;
	$content=file($full_file_name);
	if (empty($content)) $error=true;
	if ($error) {
		error("error changing /etc/postfix/master.cf \nAborting setup\n");
	}
	unset($error);
	$_content=array();
	$found=false;
	foreach ($content as $line) {
		if(preg_match('/^127.0.0.1:1002[5,7]\s+/m', $line)) $found=true;
		if ($found) {
			if (preg_match('/^\s.*\-o/i', $line) || preg_match('/^127.0.0.1:1002[5,7]\s+/m', $line)) {
			} else {
				$found = false;
			}
		} else {
			array_push($_content, $line);
		}
	}
	unset($content);
	$new = file('master.cf-dkim');
	foreach ($new as $line) {
		array_push($_content, $line);
	}
	file_put_contents('/etc/postfix/master.cf', $_content);
	$postfix = true;
} else $postfix = false;

/*
	IDS
*/
$new=file('ids.whitelist.dkim');
$full_file_name = '/usr/local/ispconfig/security/ids.whitelist';
$content = file($full_file_name);
if ( !empty($new) && is_file($full_file_name)) {
	echo "updating IDS-whitelist\n\n";
	copy($full_file_name, $full_file_name.'dkim');
	$content = file($full_file_name);
	foreach ($new as $line) {
		array_push($content, $line);
	}
	file_put_contents($full_file_name, $content);
}

/*
	PATCHED FILES
*/

//* set permissions
exec('chown -R ispconfig.ispconfig interface', $output, $result);
//* copy new files
exec('cp -Rp interface /usr/local/ispconfig', $output, $result);
exec('cp -Rp server /usr/local/ispconfig', $output, $result);
//* create symlink
if (!file_exists('/usr/local/ispconfig/server/plugins-enabled/mail_plugin_dkim.inc.php')) exec('ln -s /usr/local/ispconfig/server/plugins-available/mail_plugin_dkim.inc.php /usr/local/ispconfig/server/plugins-enabled/mail_plugin_dkim.inc.php', $output, $result);


if ($postfix) restart('postfix');

if ($amavis) {
	$pos_init=array(
		'/etc/init.d/amavis',
		'/etc/init.d/amavisd'
	);
	$initfile='';
	foreach($pos_init as $init) {
		if (is_executable($init)) {
			$initfile=$init;
			break;
		}
	}
	if ( $initfile == '' ) $initfile = 'service amavis';
	echo "restarting amavis\n";
	exec(escapeshellarg($initfile).' restart', $output);
}

echo "\nUpdate databse? [ Y | n ]?";
$answer=rtrim(fgets(STDIN));
if ($answer == '' || $answer == 'Y') {
	//* Try to read the DB-admin settings
	$clientdb_host   = '';
	$clientdb_user   = '';
	$clientdb_password  = '';
	include_once "/usr/local/ispconfig/server/lib/mysql_clientdb.conf";
	$conf["mysql"]["admin_user"] = $clientdb_user;
	$conf["mysql"]["admin_password"] = $clientdb_password;

	//** There is a error if user for mysql admin_password if empty
	if( empty($clientdb_password) ) {
    	die("internal error - MYSQL-Root passord not known");
	}

	//** Test mysql root connection
	if (!$link = mysql_connect($clientdb_host, $clientdb_user, $clientdb_password)) {
    	die("internal error - MYSQL-Root passord wrong");
	}
/*
ALTER TABLE `mail_domain` ADD `dkim_public` MEDIUMTEXT NULL AFTER `domain`;
ALTER TABLE `mail_domain` ADD `dkim_private` MEDIUMTEXT NULL AFTER `domain`;
ALTER TABLE `mail_domain` ADD `dkim` ENUM( 'n', 'y' ) NOT NULL AFTER `domain`;
ALTER TABLE `mail_domain` ADD `dkim_selector` VARCHAR(63) NOT NULL DEFAULT 'default' AFTER `dkim`;
ALTER TABLE `mail_domain` ADD `dkim_selector` VARCHAR(63) NOT NULL DEFAULT 'default' AFTER `dkim`;
ALTER TABLE `dns_rr` CHANGE `data` `data` TEXT NOT NULL DEFAULT '';
*/
	$sql="ALTER TABLE `dns_rr` CHANGE `data` `data` TEXT NOT NULL DEFAULT '';";
	mysql_db_query($conf['db_database'], $sql, $link);
}

echo "\n Setup successfull\n\n";
if (!$update) echo "Login to ISPConfig and set the DKIM-Path under System / Server-Config / Mail (not for updates)\n";

?>
